<?php  if ( ! defined('BASE')) exit('No direct script access allowed');

// include our configuration file
require_once BASE.'/voidzone/config.php';

// define useful paths for our themes
define('THEME_PATH', BASE.'/voidzone/themes/'.THEME);
define('THEME_URL', BASE_URL.'voidzone/themes/'.THEME);

class Voidzone
{
	public function __construct()
	{
		// start the routing process to decide the page
		$this->_route();
	}

	private function _route()
	{
		// if a file has been requested
		if (isset($_GET['file']))
		{
			// start the download process
			$this->_download_file();
		}
		else // otherwise
		{
			// if the file has been uploaded
			if(isset($_FILES['file']))
			{
				// store and record the file
				$this->_store_file();
			}
			else //otherwise
			{
				// show the upload form
				$this->_page_upload();
			}
		}
	}


	private function _page_upload()
	{
		// show the upload page with the correct theme
		include THEME_PATH.'/upload.php';	
	}


	private function _page_show_link($url)
	{
		// show the link to the download within the theme
		include THEME_PATH.'/link.php';		
	}

	private function _store_file()
	{
		// get a handle to the uploaded file
		$new_file = $_FILES['file'];

		// generate a unique hash
		$hash = $this->_get_hash();

		// copy the file to storage with the name (hash).vz
		copy($new_file['tmp_name'], STORAGE.'/'.$hash.'.vz');

		// create a descriptor object to store image information
		$desc['old_name'] = $new_file['name'];
		$desc['type'] = $new_file['type'];
		$desc['uploaded_when'] = time();

		// get a file handles to the .vzd descriptor file
		$h = fopen(STORAGE.'/'.$hash.'.vzd', 'w');

		// write the serialized descriptor array to the file
		fwrite($h, serialize($desc));

		// build the download link from the recorded hash
		$url = BASE_URL.'?file='.$hash;

		// show the created link within our active template
		$this->_page_show_link($url);
	}

	private function _download_file()
	{
		// get the file hash from the url
		$hash = $_GET['file'];

		// load the descriptor array from the .vzd file
		$desc = unserialize(file_get_contents(STORAGE.'/'.$hash.'.vzd'));

		// serve forced download headers, with previous file name
		header("Content-Type: application/force-download"); 
    	header("Content-Disposition: attachment; filename=\"{$desc['old_name']}\"");

    	// read the file to the browser
    	readfile(STORAGE.'/'.$hash.'.vz');		
	}

	private function _get_hash()
	{
		// start with two characters, increase by one every five
		// failed generation attempts
		$num_chars = 2;
		$times = 0;

		// make the first hash
		$hash = substr(md5(uniqid().time()), 0, $num_chars);

		// while a file with this hash exists
		while(file_exists(STORAGE.'/'.$hash.'.vz'))
		{
			// handle the counters
			if($times==5) { $num_chars++; $times = 0; }

			// generate the new hash
			$hash = substr(md5(uniqid().time()), 0, $num_chars);

			// more counters
			$times++;
		}

		// return the hash to the storage method
        return $hash;		
	}
}